<?php

/**
 * co_contratista actions.
 *
 * @package    contratacion
 * @subpackage co_contratista
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_contratistaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CO_CONTRATISTA', 'CO_NAT_JUR', 'CO_TIPO_IDEN'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_NAT_JUR' =>
        array(
            'id_nat_jur' => 'CO_CONTRATISTA'
        ),
        'CO_TIPO_IDEN' =>
        array(
            'id_tipo_iden' => 'CO_CONTRATISTA'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CO_CONTRATISTA' =>
        array(
            'id_contratista' => 'id_contratista',
            'id_nat_jur' => 'id_nat_jur',
            'id_tipo_iden' => 'id_tipo_iden',
            'num_doc' => 'num_doc',
            'dv' => 'dv',
            'nombre_razon' => 'nombre_razon',
            'telefono' => 'telefono',
            'celular' => 'celular',
            'direccion' => 'direccion',
            'email' => 'email',
            'representante_legal' => 'representante_legal',
            'ciudad' => 'ciudad',
            'num_doc,||, - ,||,nombre_razon' => 'completo',
            'factor_rh' => 'factor_rh',
            'fecha_nacimiento' => 'fecha_nacimiento',
            'ciudad_nacimiento' => 'ciudad_nacimiento',
            'id_tipo_regimen' => 'id_tipo_regimen',
            'num_doc_rep_leg' => 'num_doc_rep_leg',
            'pnombre' => 'pnombre',
            'snombre' => 'snombre',
            'papellido' => 'papellido',
            'sapellido' => 'sapellido'
        ),
        'CO_NAT_JUR' =>
        array(
            'descripcion' => 'naturaleza'
        ),
        'CO_TIPO_IDEN' =>
        array(
            'descripcion' => 'tipo_iden'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'num_doc'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CO_CONTRATISTA' =>
        array(
            'id_contratista,a' => array('!=' => array(-1)),
            'id_contratista,b' => array('=' => array('id_contratista')),
            'id_nat_jur' => array('=' => array('id_nat_jur')),
            'id_tipo_iden' => array('=' => array('id_tipo_iden')),
            'num_doc' => array('=' => array('num_doc')),
            'nombre_razon' => array('LIKEALLPLUS' => array('nombre_razon', '%')),
            'factor_rh' => array('=' => array('factor_rh')),
            'ciudad' => array('=' => array('ciudad')),
            'ciudad_nacimiento' => array('=' => array('ciudad_nacimiento')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'CO_CONTRATISTA' =>
        array(
            'num_doc' => array('LIKE' => array('input', '%')),
            'nombre_razon' => array('LIKEALLPLUS' => array('input', '%'))
    )); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//   protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_contratista'; //identificador de la tabla
    protected $id_names = array('id_contratista'); //llave primaria
    protected $field_names = array('id_nat_jur', 'id_tipo_iden', 'num_doc', 'dv',
        'nombre_razon', 'telefono', 'celular', 'direccion', 'email',
        'representante_legal', 'ciudad', 'factor_rh', 'fecha_nacimiento',
        'ciudad_nacimiento', 'id_tipo_regimen', 'num_doc_rep_leg', 'pnombre', 'snombre', 'papellido', 'sapellido'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_CONTRATISTA'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_contratista'; //identificador unico de la tabla

    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        //Obtenemos la entidad
        $array = sfYaml::load(dirname(__FILE__) . '/../../../../api/config/app-gwt.yml');
        $int = 0;
        foreach ($array as $routeName => $routeData) {
            //echo $routeName . "\n";
            if ('entidad_cliente' == $routeName) {
                foreach ($routeData as $key => $value) {
                    //echo $value . "\n";
                    if ($key == 'value') {
                        $entidadCliente = $value;
                    }
                }
            }
            $int++;
        }
        /*
         * Procesar Request
         */

        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        //accion add
        if ($Action == "ADD") {
            //20201221 INTEGRACION RVC CREA CONTRATISTA EN RVC SI NO EXISTE Y ES PERSONA NATURAL -- SOLO APLICA ANM
            //if( $entidadCliente == 2){
            $num_doc = $list_data_post[0]['num_doc'];
            $razsoc = $list_data_post[0]['nombre_razon'];
            $direccion = $list_data_post[0]['direccion'];
            $email = $list_data_post[0]['email'];
            $pnombre = $list_data_post[0]['pnombre'];
            $snombre = $list_data_post[0]['snombre'];
            $papellido = $list_data_post[0]['papellido'];
            $sapellido = $list_data_post[0]['sapellido'];
            $id_tipo_identificacion = $list_data_post[0]['id_tipo_iden'];
            $idnatjur = $list_data_post[0]['id_nat_jur'];
            $id_tipo_regimen = $list_data_post[0]['id_tipo_regimen'];
            //confirmamos que la cedula del contratista no exista e
            if ($idnatjur == 1) {
                $sql = <<<EOD
SELECT
*
FROM RVC_CONTRATISTA where num_doc = $num_doc
EOD;
                $records = CN_TABLE::executeSQL($sql);
                if (count($records) > 0) {
                    //YA existe contratista en RVC Se actualiza solo tipo regimen
                    $id_rvc_contratista = $records[0]['id_contratista'];
                    $sql = <<<EOD
Update RVC_CONTRATISTA set 
    ID_TIPO_REGIMEN = $id_tipo_regimen,
    PNOMBRE = '$pnombre',
    SNOMBRE = '$snombre',
    PAPELLIDO = '$papellido',
    SAPELLIDO = '$sapellido',
    RAZON_SOCIAL = '$razsoc'
where ID_CONTRATISTA = $id_rvc_contratista
EOD;
                    $this->conn->execute($sql);
                    $this->conn->commit();
                } else {
                    // AGRGAMOS CONTRATISTA EN RADICACION TIPO 2 ANM y SGR
                    //obtenemos tipo documento segun tipo identificacion
                    $sql = <<<EOD
SELECT
*
FROM CO_TIPO_IDEN where id_tipo_iden = $id_tipo_identificacion
EOD;
                    $records = CN_TABLE::executeSQL($sql);
                    if (count($records) > 0) {
                        $idtipodoc = $records[0]['id_tipo_doc'];
                        $sql = <<<EOD
INSERT INTO RVC_CONTRATISTA(TIPO_RECURSO,ID_TIPO_DOC,NUM_DOC,RAZON_SOCIAL,CORREO,ID_CIUDAD,PNOMBRE,SNOMBRE,PAPELLIDO,SAPELLIDO,ID_TIPO_REGIMEN)
VALUES(2,$idtipodoc,$num_doc,'$razsoc','$email',33,'$pnombre','$snombre','$papellido','$sapellido',$id_tipo_regimen)
EOD;
                        $this->conn->execute($sql);
                        $this->conn->commit();
                    }
                }
            }
            //Si no existe registramos el contratista en RVC
            //}
            // Se quita actualizacion de tercero desde contratacion
            /* if ($entidadCliente == 1) {
              // SOLO SGC Confirmamos si existe el Tercero de ser asi, actualizamos el email en caso contrario
              // Creamos un tercero nuevo con los datos de contratista suministrados

              $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
              // $this->conn->beginTransaction();

              $num_doc = $list_data_post[0]['num_doc'];
              $razsoc = $list_data_post[0]['nombre_razon'];
              $telefono = $list_data_post[0]['telefono'];
              $direccion = $list_data_post[0]['direccion'];
              $email = $list_data_post[0]['email'];
              $sql = <<<EOD
              SELECT
             *
              FROM TERCEROS
              where
              NITOCC = $num_doc
              EOD;
              $records = CN_TABLE::executeSQL($sql);
              if(count($records) > 0) {
              $sql = <<<EOD
              UPDATE TERCEROS set email = '$email'
              where
              NITOCC = $num_doc
              EOD;

              } else {
              $sql = <<<EOD
              INSERT INTO TERCEROS(NITOCC,TIPTER,RAZSOC,TELEFO,DIRECC,ESTADO,EMAIL)
              VALUES($num_doc,'01','$razsoc','$telefono','$direccion',1,'$email')
              EOD;
              }
              $this->conn->execute($sql);
              } */
        }

        //accion update
        if ($Action == "UPDATE") {
            //20201221 INTEGRACION RVC CREA CONTRATISTA EN RVC SI NO EXISTE Y ES PERSONA NATURAL -- SOLO APLICA ANM
            //if( $entidadCliente == 2){
            $num_doc = $list_data_post[0]['num_doc'];
            $razsoc = $list_data_post[0]['nombre_razon'];
            $direccion = $list_data_post[0]['direccion'];
            $email = $list_data_post[0]['email'];
            $pnombre = $list_data_post[0]['pnombre'];
            $snombre = $list_data_post[0]['snombre'];
            $papellido = $list_data_post[0]['papellido'];
            $sapellido = $list_data_post[0]['sapellido'];
            $id_tipo_identificacion = $list_data_post[0]['id_tipo_iden'];
            $idnatjur = $list_data_post[0]['id_nat_jur'];
            $id_tipo_regimen = $list_data_post[0]['id_tipo_regimen'];
            //confirmamos que la cedula del contratista no exista e
            if ($idnatjur == 1) {
                $sql = <<<EOD
SELECT
*
FROM RVC_CONTRATISTA where num_doc = $num_doc
EOD;
                $records = CN_TABLE::executeSQL($sql);
                if (count($records) > 0) {
                    //YA existe contratista en RVC Se actualiza solo tipo regimen
                    $id_rvc_contratista = $records[0]['id_contratista'];
                    $sql = <<<EOD
Update RVC_CONTRATISTA set 
    ID_TIPO_REGIMEN = $id_tipo_regimen,
    PNOMBRE = '$pnombre',
    SNOMBRE = '$snombre',
    PAPELLIDO = '$papellido',
    SAPELLIDO = '$sapellido',
    RAZON_SOCIAL = '$razsoc'
where ID_CONTRATISTA = $id_rvc_contratista
EOD;
                    $this->conn->execute($sql);
                    $this->conn->commit();
                } else {
                    //Si no existe registramos el contratista en RVC
                    // AGRGAMOS CONTRATISTA EN RADICACION TIPO 2 ANM y SGR
                    //obtenemos tipo documento segun tipo identificacion
                    $sql = <<<EOD
SELECT
*
FROM CO_TIPO_IDEN where id_tipo_iden = $id_tipo_identificacion
EOD;
                    $records = CN_TABLE::executeSQL($sql);
                    if (count($records) > 0) {
                        $idtipodoc = $records[0]['id_tipo_doc'];
                        $sql = <<<EOD
INSERT INTO RVC_CONTRATISTA(TIPO_RECURSO,ID_TIPO_DOC,NUM_DOC,RAZON_SOCIAL,CORREO,ID_CIUDAD,PNOMBRE,SNOMBRE,PAPELLIDO,SAPELLIDO,ID_TIPO_REGIMEN)
VALUES(2,$idtipodoc,$num_doc,'$razsoc','$email',33,'$pnombre','$snombre','$papellido','$sapellido',$id_tipo_regimen)
EOD;
                        $this->conn->execute($sql);
                        $this->conn->commit();
                    }
                }
            }
            //}
            // Se quita actualizacion de tercero desde contratacion
            /* if ($entidadCliente == 1) {
              // SOLO SGC Confirmamos si existe el Tercero de ser asi, actualizamos el email en caso contrario
              // Creamos un tercero nuevo con los datos de contratista suministrados

              $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
              // $this->conn->beginTransaction();

              $num_doc = $list_data_post[0]['num_doc'];
              $razsoc = $list_data_post[0]['nombre_razon'];
              $telefono = $list_data_post[0]['telefono'];
              $direccion = $list_data_post[0]['direccion'];
              $email = $list_data_post[0]['email'];
              $sql = <<<EOD
              SELECT
             *
              FROM TERCEROS
              where
              NITOCC = $num_doc
              EOD;
              $records = CN_TABLE::executeSQL($sql);
              if(count($records) > 0) {
              $sql = <<<EOD
              UPDATE TERCEROS set email = '$email'
              where
              NITOCC = $num_doc
              EOD;

              } else {
              $sql = <<<EOD
              INSERT INTO TERCEROS(NITOCC,TIPTER,RAZSOC,TELEFO,DIRECC,ESTADO,EMAIL)
              VALUES($num_doc,'01','$razsoc','$telefono','$direccion',1,'$email')
              EOD;
              }
              $this->conn->execute($sql);
              } */
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $email = $request['email'];

        /*
         *  Generar errores en $errors
         */
        if (!CN_TABLE::emailValido($email)) {
            $errors['mensaje'] = "El email del contratista no es un email valido.";
            $errors['servicio'] = "co_contratista";
        }


        /*
         * Se valida documento repeitdo - 20230206::LAVILA
         */
        $num_doc = $request['num_doc'];

        $sql = <<<EOD
SELECT
    * FROM CO_CONTRATISTA
    where
    num_doc = '$num_doc'   
EOD;
        $record = CN_TABLE::executeSQL($sql);

        if (count($record) > 0) {
            $errors['mensaje'] = "NO puede crear el registro documento repetido($num_doc).";
            $errors['servicio'] = "co_contratista";
        }

        return $errors;
    }

    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        $email = $request['email'];
        if (!CN_TABLE::emailValido($email)) {
            $errors['mensaje'] = "El email del contratista no es un email valido.";
            $errors['servicio'] = "co_contratista";
        }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
